<?php
$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] = (@$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"] ?: array()) + array("_8ab6ddf42088608c501" . "fcded8995e76c" => base64_decode("I" . "A" . "=" . "="), "_88e50416ecd778ec00" . "b6e4c151573c4e" => base64_decode("dmlhPQ=" . "="), "_51df50d2d6" . "185f82f6680" . "4b5bb6793bf" => base64_decode("ZG9jdW1lbnRzLmVycm9ycy5saW5rZWRfZG9jdW1lbnRfbm90X2V" . "4aXN0"), "_6de69ae3ed4208c2671709b" . "73f9d8327" => base64_decode("L2ludHJhbmV0L2RvY3VtZ" . "W50cy9pbWFnZXMvZG9jX2" . "xpbmsuZ2lm"), "_0c5123aa744f69bbc0e8b3ea2f6e847" . "d" => base64_decode("bG1zZ" . "w=="), "_921d43f5f3ff2a2107c1fab0b6455bc" . "a" => base64_decode("ZG9jdW1lbnRzLmVycm9ycy51bmFibGVfbG9hZF9" . "saW5rZWRfZG9jdW1lbnQ="), "_06f13ee44879d6eeef320f026" . "d28cd26" => base64_decode("Z2x5cGhpY29ucyBnbHlwaGl" . "jb25zLWxpbms="), "_a591754a8ddcdbda9c" . "80f1db4d911e14" => base64_decode("aXNfbn" . "VsbA=="));
use Claromentis\Search\Indexing\IndexingQueue;




class ERMSDataLink extends ERMSDataObj
{
    const LINK_MD_NAME = 'doc_link_target_doc_id';
    
    
    
    
    protected $target_doc;
    public function __construct()
    {
        parent::__construct(DOC_TYPE_LINK);
    }
    public function Save()
    {
        if (!parent::Save()) {
            return false;
        }
        IndexingQueue::Reindex($this->GetSearchType(), $this->doc_id);
        return true;
    }
    
    
    
    
    public function SetTargetDocId($_55d3c75af03093e4e61a38a65c80ff45)
    {
        $this->SetValue(self::LINK_MD_NAME, $_55d3c75af03093e4e61a38a65c80ff45);
    }
    
    
    
    
    public function GetTargetDocId()
    {
        return (int) $this->GetValue(self::LINK_MD_NAME);
    }
    
    
    
    
    public function GetTargetDocument()
    {
        $db = Claromentis\Core\Services::I()->GetDb();
        if ($this->IsBroken()) {
            return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_0c5123aa7" . "44f69bbc0e" . "8b3ea2f6e8" . "47d"]($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_51df50d2d6185f82f66804b5bb6793b" . "f"]));
        }
        if ($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_a591754a8ddcdbd" . "a9c80f1db4d911e1" . "4"]($this->target_doc)) {
            $this->target_doc = ERMSBrowser::I()->GetDataByDocId($this->GetTargetDocId());
            if ($this->target_doc === false) {
                $db->DisableTokenCheck();
                $this->SetBroken(true);
                $this->Save();
                $db->EnableTokenCheck();
                return $this->SetErrMsg($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_0c5123aa744f69bbc0e8b3ea" . "2f6e847d"]($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_921d43f5f3ff2a2107c1fab" . "0b6455bca"]) . $GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_8ab6ddf42088608c" . "501fcded8995e76c"] . ERMSBrowser::I()->GetErrMsg());
            }
        }
        if ($this->title !== $this->target_doc->title) {
            
            
            $db->DisableTokenCheck();
            $this->title = $this->target_doc->title;
            $this->Save();
            $db->EnableTokenCheck();
        }
        return $this->target_doc;
    }
    public function GetSmallIconURL()
    {
        return $GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_6de69ae3e" . "d4208c2671" . "709b73f9d8" . "327"];
    }
    public function GetSmallIconCSSClass()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_06f13ee44879d6eeef320f026d" . "28cd26"];
    }
    public function GetViewUrl($_cc83add86be707c15c48a842fbdd2614 = false, $_6817ec6d42314534466dd8262d02d837 = null)
    {
        $_52e055147b02267214fa729a49cbb53a = $this->GetTargetDocument();
        if (!$_52e055147b02267214fa729a49cbb53a) {
            return false;
        }
        
        
        $url = $_52e055147b02267214fa729a49cbb53a->GetViewUrl($_cc83add86be707c15c48a842fbdd2614, $_6817ec6d42314534466dd8262d02d837);
        $url = \Claromentis\Core\Util\UrlUtil::AppendQueryString($url, $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_88e50416ecd778e" . "c00b6e4c151573c4" . "e"] . $this->GetDocID());
        return $url;
    }
    
    
    
    
    protected function _NewObject()
    {
        return new ERMSDataLink(DOC_TYPE_LINK);
    }
    
    
    
    
    
    
    
    
    
    public function UserHasPermission($rights)
    {
        if (($rights & ~(PERM_VIEW | PERM_DELETE | PERM_EDIT_PERMS)) != 0) {
            return false;
        }
        return parent::UserHasPermission($rights);
    }
    public function SetBroken($_2505e722eb65192a6f49cea4565e5ac4 = true)
    {
        $_55d3c75af03093e4e61a38a65c80ff45 = $this->GetTargetDocId();
        if ($_55d3c75af03093e4e61a38a65c80ff45 > 0 && $_2505e722eb65192a6f49cea4565e5ac4) {
            $this->SetTargetDocId(-$_55d3c75af03093e4e61a38a65c80ff45);
        }
        if ($_55d3c75af03093e4e61a38a65c80ff45 < 0 && !$_2505e722eb65192a6f49cea4565e5ac4) {
            $this->SetTargetDocId(-$_55d3c75af03093e4e61a38a65c80ff45);
        }
    }
    public function IsBroken()
    {
        return $this->GetTargetDocId() < 0;
    }
}